/* umockdev-pcap.c generated by valac 0.56.17, the Vala compiler
 * generated from umockdev-pcap.vala, do not modify */

/*
 * Copyright (C) 2021 Red Hat Inc.
 * Author: Benjamin Berg <bberg@redhat.com>
 *
 * umockdev is free software; you can redistribute it and/or
 * modify it under the terms of the GNU Lesser General Public
 * License as published by the Free Software Foundation; either
 * version 2.1 of the License, or (at your option) any later version.
 *
 * umockdev is distributed in the hope that it will be useful, but
 * WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the GNU
 * Lesser General Public License for more details.
 *
 * You should have received a copy of the GNU Lesser General Public License
 * along with this program; If not, see <http://www.gnu.org/licenses/>.
 */

#include <glib.h>
#include <stdlib.h>
#include <string.h>
#include <glib-object.h>
#include "umockdev.h"
#include <pcap/pcap.h>
#include "linux/usbdevice_fs.h"
#include <pcap/dlt.h>
#include "linux/ioctl.h"
#include <gio/gio.h>
#include "sys/ioctl.h"
#include <errno.h>
#include <pcap/usb.h>
#include <stdio.h>

#define UMOCKDEV_URB_TRANSFER_IN 0x80
#define UMOCKDEV_URB_ISOCHRONOUS 0x0
#define UMOCKDEV_URB_INTERRUPT 0x1
#define UMOCKDEV_URB_CONTROL 0x2
#define UMOCKDEV_URB_BULK 0x3
#define UMOCKDEV_IOCTL_USB_PCAP_HANDLER_capabilities ((guint32) ((((USBDEVFS_CAP_BULK_SCATTER_GATHER | USBDEVFS_CAP_BULK_CONTINUATION) | USBDEVFS_CAP_NO_PACKET_SIZE_LIM) | USBDEVFS_CAP_REAP_AFTER_DISCONNECT) | USBDEVFS_CAP_ZERO_PACKET))
#if !defined(VALA_STRICT_C)
#if !defined(__clang__) && defined(__GNUC__) && (__GNUC__ >= 14)
#pragma GCC diagnostic warning "-Wincompatible-pointer-types"
#elif defined(__clang__) && (__clang_major__ >= 16)
#pragma clang diagnostic ignored "-Wincompatible-function-pointer-types"
#pragma clang diagnostic ignored "-Wincompatible-pointer-types"
#endif
#endif

#define UMOCKDEV_TYPE_URB_INFO (umockdev_urb_info_get_type ())
typedef struct _UMockdevUrbInfo UMockdevUrbInfo;
#define _g_object_unref0(var) ((var == NULL) ? NULL : (var = (g_object_unref (var), NULL)))

#define UMOCKDEV_TYPE_IOCTL_USB_PCAP_HANDLER (umockdev_ioctl_usb_pcap_handler_get_type ())
#define UMOCKDEV_IOCTL_USB_PCAP_HANDLER(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), UMOCKDEV_TYPE_IOCTL_USB_PCAP_HANDLER, UMockdevIoctlUsbPcapHandler))
#define UMOCKDEV_IOCTL_USB_PCAP_HANDLER_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), UMOCKDEV_TYPE_IOCTL_USB_PCAP_HANDLER, UMockdevIoctlUsbPcapHandlerClass))
#define UMOCKDEV_IS_IOCTL_USB_PCAP_HANDLER(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), UMOCKDEV_TYPE_IOCTL_USB_PCAP_HANDLER))
#define UMOCKDEV_IS_IOCTL_USB_PCAP_HANDLER_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), UMOCKDEV_TYPE_IOCTL_USB_PCAP_HANDLER))
#define UMOCKDEV_IOCTL_USB_PCAP_HANDLER_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), UMOCKDEV_TYPE_IOCTL_USB_PCAP_HANDLER, UMockdevIoctlUsbPcapHandlerClass))

typedef struct _UMockdevIoctlUsbPcapHandler UMockdevIoctlUsbPcapHandler;
typedef struct _UMockdevIoctlUsbPcapHandlerClass UMockdevIoctlUsbPcapHandlerClass;
typedef struct _UMockdevIoctlUsbPcapHandlerPrivate UMockdevIoctlUsbPcapHandlerPrivate;
enum  {
	UMOCKDEV_IOCTL_USB_PCAP_HANDLER_0_PROPERTY,
	UMOCKDEV_IOCTL_USB_PCAP_HANDLER_NUM_PROPERTIES
};
static GParamSpec* umockdev_ioctl_usb_pcap_handler_properties[UMOCKDEV_IOCTL_USB_PCAP_HANDLER_NUM_PROPERTIES];
#define _pcap_close0(var) ((var == NULL) ? NULL : (var = (pcap_close (var), NULL)))
#define _g_array_unref0(var) ((var == NULL) ? NULL : (var = (g_array_unref (var), NULL)))
#define _g_error_free0(var) ((var == NULL) ? NULL : (var = (g_error_free (var), NULL)))
#define _umockdev_urb_info_free0(var) ((var == NULL) ? NULL : (var = (umockdev_urb_info_free (var), NULL)))
#define _g_free0(var) (var = (g_free (var), NULL))
#define _vala_assert(expr, msg) if G_LIKELY (expr) ; else g_assertion_message_expr (G_LOG_DOMAIN, __FILE__, __LINE__, G_STRFUNC, msg);
#define _vala_return_if_fail(expr, msg) if G_LIKELY (expr) ; else { g_return_if_fail_warning (G_LOG_DOMAIN, G_STRFUNC, msg); return; }
#define _vala_return_val_if_fail(expr, msg, val) if G_LIKELY (expr) ; else { g_return_if_fail_warning (G_LOG_DOMAIN, G_STRFUNC, msg); return val; }
#define _vala_warn_if_fail(expr, msg) if G_LIKELY (expr) ; else g_warn_message (G_LOG_DOMAIN, __FILE__, __LINE__, G_STRFUNC, msg);

struct _UMockdevUrbInfo {
	UMockdevIoctlData* urb_data;
	UMockdevIoctlData* buffer_data;
	guint64 pcap_id;
};

struct _UMockdevIoctlUsbPcapHandler {
	UMockdevIoctlBase parent_instance;
	UMockdevIoctlUsbPcapHandlerPrivate * priv;
};

struct _UMockdevIoctlUsbPcapHandlerClass {
	UMockdevIoctlBaseClass parent_class;
};

struct _UMockdevIoctlUsbPcapHandlerPrivate {
	pcap_t* rec;
	GArray* urbs;
	GArray* discarded;
	gint bus;
	gint device;
	struct pcap_pkthdr cur_hdr;
	guint64 start_time_ms;
	guint64 last_pkt_time_ms;
	guint64 cur_waiting_since;
	guint8* cur_buf;
	gint cur_buf_length1;
	gint _cur_buf_size_;
};

static gint UMockdevIoctlUsbPcapHandler_private_offset;
static gpointer umockdev_ioctl_usb_pcap_handler_parent_class = NULL;

VALA_EXTERN gchar* umockdev_urb_type_to_string (gint type);
VALA_EXTERN GType umockdev_urb_info_get_type (void) G_GNUC_CONST ;
VALA_EXTERN UMockdevUrbInfo* umockdev_urb_info_dup (const UMockdevUrbInfo* self);
VALA_EXTERN void umockdev_urb_info_free (UMockdevUrbInfo* self);
VALA_EXTERN void umockdev_urb_info_copy (const UMockdevUrbInfo* self,
                             UMockdevUrbInfo* dest);
VALA_EXTERN void umockdev_urb_info_destroy (UMockdevUrbInfo* self);
VALA_EXTERN GType umockdev_ioctl_usb_pcap_handler_get_type (void) G_GNUC_CONST ;
VALA_EXTERN UMockdevIoctlUsbPcapHandler* umockdev_ioctl_usb_pcap_handler_new (const gchar* file,
                                                                  gint bus,
                                                                  gint device);
VALA_EXTERN UMockdevIoctlUsbPcapHandler* umockdev_ioctl_usb_pcap_handler_construct (GType object_type,
                                                                        const gchar* file,
                                                                        gint bus,
                                                                        gint device);
static void _umockdev_urb_info_free0_ (gpointer var);
static void _vala_UMockdevUrbInfo_free_function_content_of (gpointer data);
static gboolean umockdev_ioctl_usb_pcap_handler_real_handle_ioctl (UMockdevIoctlBase* base,
                                                            UMockdevIoctlClient* client);
static UMockdevUrbInfo* umockdev_ioctl_usb_pcap_handler_next_reapable_urb (UMockdevIoctlUsbPcapHandler* self);
static void umockdev_ioctl_usb_pcap_handler_finalize (GObject * obj);
static GType umockdev_ioctl_usb_pcap_handler_get_type_once (void);
static inline gpointer _vala_memdup2 (gconstpointer mem,
                        gsize byte_size);

gchar*
umockdev_urb_type_to_string (gint type)
{
	gchar* result;
#line 32 "../src/umockdev-pcap.vala"
	switch (type) {
#line 32 "../src/umockdev-pcap.vala"
		case UMOCKDEV_URB_INTERRUPT:
#line 148 "umockdev-pcap.c"
		{
			gchar* _tmp0_;
#line 34 "../src/umockdev-pcap.vala"
			_tmp0_ = g_strdup ("INTERRUPT");
#line 34 "../src/umockdev-pcap.vala"
			result = _tmp0_;
#line 34 "../src/umockdev-pcap.vala"
			return result;
#line 157 "umockdev-pcap.c"
		}
#line 32 "../src/umockdev-pcap.vala"
		case UMOCKDEV_URB_CONTROL:
#line 161 "umockdev-pcap.c"
		{
			gchar* _tmp1_;
#line 36 "../src/umockdev-pcap.vala"
			_tmp1_ = g_strdup ("CONTROL");
#line 36 "../src/umockdev-pcap.vala"
			result = _tmp1_;
#line 36 "../src/umockdev-pcap.vala"
			return result;
#line 170 "umockdev-pcap.c"
		}
#line 32 "../src/umockdev-pcap.vala"
		case UMOCKDEV_URB_BULK:
#line 174 "umockdev-pcap.c"
		{
			gchar* _tmp2_;
#line 38 "../src/umockdev-pcap.vala"
			_tmp2_ = g_strdup ("BULK");
#line 38 "../src/umockdev-pcap.vala"
			result = _tmp2_;
#line 38 "../src/umockdev-pcap.vala"
			return result;
#line 183 "umockdev-pcap.c"
		}
		default:
		{
			gchar* _tmp3_;
#line 40 "../src/umockdev-pcap.vala"
			_tmp3_ = g_strdup_printf ("UNKNOWN (%d)", type);
#line 40 "../src/umockdev-pcap.vala"
			result = _tmp3_;
#line 40 "../src/umockdev-pcap.vala"
			return result;
#line 194 "umockdev-pcap.c"
		}
	}
}

static gpointer
_g_object_ref0 (gpointer self)
{
#line 44 "../src/umockdev-pcap.vala"
	return self ? g_object_ref (self) : NULL;
#line 204 "umockdev-pcap.c"
}

void
umockdev_urb_info_copy (const UMockdevUrbInfo* self,
                        UMockdevUrbInfo* dest)
{
	UMockdevIoctlData* _tmp0_;
	UMockdevIoctlData* _tmp1_;
	UMockdevIoctlData* _tmp2_;
	UMockdevIoctlData* _tmp3_;
#line 44 "../src/umockdev-pcap.vala"
	_tmp0_ = (*self).urb_data;
#line 44 "../src/umockdev-pcap.vala"
	_tmp1_ = _g_object_ref0 (_tmp0_);
#line 44 "../src/umockdev-pcap.vala"
	_g_object_unref0 ((*dest).urb_data);
#line 44 "../src/umockdev-pcap.vala"
	(*dest).urb_data = _tmp1_;
#line 44 "../src/umockdev-pcap.vala"
	_tmp2_ = (*self).buffer_data;
#line 44 "../src/umockdev-pcap.vala"
	_tmp3_ = _g_object_ref0 (_tmp2_);
#line 44 "../src/umockdev-pcap.vala"
	_g_object_unref0 ((*dest).buffer_data);
#line 44 "../src/umockdev-pcap.vala"
	(*dest).buffer_data = _tmp3_;
#line 44 "../src/umockdev-pcap.vala"
	(*dest).pcap_id = (*self).pcap_id;
#line 233 "umockdev-pcap.c"
}

void
umockdev_urb_info_destroy (UMockdevUrbInfo* self)
{
#line 45 "../src/umockdev-pcap.vala"
	_g_object_unref0 ((*self).urb_data);
#line 46 "../src/umockdev-pcap.vala"
	_g_object_unref0 ((*self).buffer_data);
#line 243 "umockdev-pcap.c"
}

UMockdevUrbInfo*
umockdev_urb_info_dup (const UMockdevUrbInfo* self)
{
	UMockdevUrbInfo* dup;
#line 44 "../src/umockdev-pcap.vala"
	dup = g_new0 (UMockdevUrbInfo, 1);
#line 44 "../src/umockdev-pcap.vala"
	umockdev_urb_info_copy (self, dup);
#line 44 "../src/umockdev-pcap.vala"
	return dup;
#line 256 "umockdev-pcap.c"
}

void
umockdev_urb_info_free (UMockdevUrbInfo* self)
{
#line 44 "../src/umockdev-pcap.vala"
	umockdev_urb_info_destroy (self);
#line 44 "../src/umockdev-pcap.vala"
	g_free (self);
#line 266 "umockdev-pcap.c"
}

static GType
umockdev_urb_info_get_type_once (void)
{
	GType umockdev_urb_info_type_id;
	umockdev_urb_info_type_id = g_boxed_type_register_static ("UMockdevUrbInfo", (GBoxedCopyFunc) umockdev_urb_info_dup, (GBoxedFreeFunc) umockdev_urb_info_free);
	return umockdev_urb_info_type_id;
}

GType
umockdev_urb_info_get_type (void)
{
	static volatile gsize umockdev_urb_info_type_id__once = 0;
	if (g_once_init_enter (&umockdev_urb_info_type_id__once)) {
		GType umockdev_urb_info_type_id;
		umockdev_urb_info_type_id = umockdev_urb_info_get_type_once ();
		g_once_init_leave (&umockdev_urb_info_type_id__once, umockdev_urb_info_type_id);
	}
	return umockdev_urb_info_type_id__once;
}

static inline gpointer
umockdev_ioctl_usb_pcap_handler_get_instance_private (UMockdevIoctlUsbPcapHandler* self)
{
	return G_STRUCT_MEMBER_P (self, UMockdevIoctlUsbPcapHandler_private_offset);
}

static void
_umockdev_urb_info_free0_ (gpointer var)
{
#line 78 "../src/umockdev-pcap.vala"
	(var == NULL) ? NULL : (var = (umockdev_urb_info_free (var), NULL));
#line 300 "umockdev-pcap.c"
}

static void
_vala_UMockdevUrbInfo_free_function_content_of (gpointer data)
{
	UMockdevUrbInfo* self;
#line 78 "../src/umockdev-pcap.vala"
	self = *((UMockdevUrbInfo**) data);
#line 78 "../src/umockdev-pcap.vala"
	_umockdev_urb_info_free0_ (self);
#line 311 "umockdev-pcap.c"
}

UMockdevIoctlUsbPcapHandler*
umockdev_ioctl_usb_pcap_handler_construct (GType object_type,
                                           const gchar* file,
                                           gint bus,
                                           gint device)
{
	UMockdevIoctlUsbPcapHandler * self = NULL;
	gchar errbuf[PCAP_ERRBUF_SIZE] = {0};
	pcap_t* _tmp0_;
	pcap_t* _tmp1_;
	GArray* _tmp2_;
	GArray* _tmp3_;
#line 65 "../src/umockdev-pcap.vala"
	g_return_val_if_fail (file != NULL, NULL);
#line 68 "../src/umockdev-pcap.vala"
	self = (UMockdevIoctlUsbPcapHandler*) umockdev_ioctl_base_construct (object_type);
#line 70 "../src/umockdev-pcap.vala"
	self->priv->bus = bus;
#line 71 "../src/umockdev-pcap.vala"
	self->priv->device = device;
#line 73 "../src/umockdev-pcap.vala"
	_tmp0_ = pcap_open_offline (file, errbuf);
#line 73 "../src/umockdev-pcap.vala"
	_pcap_close0 (self->priv->rec);
#line 73 "../src/umockdev-pcap.vala"
	self->priv->rec = _tmp0_;
#line 75 "../src/umockdev-pcap.vala"
	_tmp1_ = self->priv->rec;
#line 75 "../src/umockdev-pcap.vala"
	if (pcap_datalink (_tmp1_) != DLT_USB_LINUX_MMAPPED) {
#line 76 "../src/umockdev-pcap.vala"
		g_error ("umockdev-pcap.vala:76: Only DLT_USB_LINUX_MMAPPED recordings are suppo" \
"rted!");
#line 346 "umockdev-pcap.c"
	}
#line 78 "../src/umockdev-pcap.vala"
	_tmp2_ = g_array_new (TRUE, TRUE, sizeof (UMockdevUrbInfo*));
#line 78 "../src/umockdev-pcap.vala"
	g_array_set_clear_func (_tmp2_, (GDestroyNotify) _vala_UMockdevUrbInfo_free_function_content_of);
#line 78 "../src/umockdev-pcap.vala"
	_g_array_unref0 (self->priv->urbs);
#line 78 "../src/umockdev-pcap.vala"
	self->priv->urbs = _tmp2_;
#line 79 "../src/umockdev-pcap.vala"
	_tmp3_ = g_array_new (TRUE, TRUE, sizeof (UMockdevUrbInfo*));
#line 79 "../src/umockdev-pcap.vala"
	g_array_set_clear_func (_tmp3_, (GDestroyNotify) _vala_UMockdevUrbInfo_free_function_content_of);
#line 79 "../src/umockdev-pcap.vala"
	_g_array_unref0 (self->priv->discarded);
#line 79 "../src/umockdev-pcap.vala"
	self->priv->discarded = _tmp3_;
#line 65 "../src/umockdev-pcap.vala"
	return self;
#line 366 "umockdev-pcap.c"
}

UMockdevIoctlUsbPcapHandler*
umockdev_ioctl_usb_pcap_handler_new (const gchar* file,
                                     gint bus,
                                     gint device)
{
#line 65 "../src/umockdev-pcap.vala"
	return umockdev_ioctl_usb_pcap_handler_construct (UMOCKDEV_TYPE_IOCTL_USB_PCAP_HANDLER, file, bus, device);
#line 376 "umockdev-pcap.c"
}

static gpointer
_umockdev_urb_info_dup0 (gpointer self)
{
#line 113 "../src/umockdev-pcap.vala"
	return self ? umockdev_urb_info_dup (self) : NULL;
#line 384 "umockdev-pcap.c"
}

static gpointer
vala_g_array_remove_index (GArray* self,
                           guint index)
{
	gpointer g = NULL;
	gpointer* _tmp0_;
	gint _tmp0__length1;
	gpointer _tmp1_;
	gpointer result;
#line 6182 "glib-2.0.vapi"
	g_return_val_if_fail (self != NULL, NULL);
#line 6183 "glib-2.0.vapi"
	_vala_assert (self->len > index, "length > index");
#line 6184 "glib-2.0.vapi"
	_tmp0_ = self->data;
#line 6184 "glib-2.0.vapi"
	_tmp0__length1 = self->len;
#line 6184 "glib-2.0.vapi"
	_tmp1_ = _tmp0_[index];
#line 6184 "glib-2.0.vapi"
	_tmp0_[index] = NULL;
#line 6184 "glib-2.0.vapi"
	g = _tmp1_;
#line 6185 "glib-2.0.vapi"
	g_array_remove_index (self, index);
#line 6186 "glib-2.0.vapi"
	result = g;
#line 6186 "glib-2.0.vapi"
	return result;
#line 416 "umockdev-pcap.c"
}

static gboolean
umockdev_ioctl_usb_pcap_handler_real_handle_ioctl (UMockdevIoctlBase* base,
                                                   UMockdevIoctlClient* client)
{
	UMockdevIoctlUsbPcapHandler * self;
	UMockdevIoctlData* data = NULL;
	gulong request = 0UL;
	gulong _tmp0_;
	gulong _tmp1_;
	gulong size = 0UL;
	GError* _inner_error0_ = NULL;
	gboolean result;
#line 82 "../src/umockdev-pcap.vala"
	self = (UMockdevIoctlUsbPcapHandler*) base;
#line 82 "../src/umockdev-pcap.vala"
	g_return_val_if_fail (client != NULL, FALSE);
#line 83 "../src/umockdev-pcap.vala"
	data = NULL;
#line 84 "../src/umockdev-pcap.vala"
	_tmp0_ = umockdev_ioctl_client_get_request (client);
#line 84 "../src/umockdev-pcap.vala"
	_tmp1_ = _tmp0_;
#line 84 "../src/umockdev-pcap.vala"
	request = _tmp1_;
#line 85 "../src/umockdev-pcap.vala"
	size = (request >> _IOC_SIZESHIFT) & ((1 << _IOC_SIZEBITS) - 1);
#line 445 "umockdev-pcap.c"
	{
		UMockdevIoctlData* _tmp2_ = NULL;
		UMockdevIoctlData* _tmp3_;
		UMockdevIoctlData* _tmp4_;
		UMockdevIoctlData* _tmp5_;
		UMockdevIoctlData* _tmp7_;
#line 88 "../src/umockdev-pcap.vala"
		_tmp3_ = umockdev_ioctl_client_get_arg (client);
#line 88 "../src/umockdev-pcap.vala"
		_tmp4_ = _tmp3_;
#line 88 "../src/umockdev-pcap.vala"
		_tmp5_ = umockdev_ioctl_data_resolve (_tmp4_, (gsize) 0, (gsize) size, &_inner_error0_);
#line 88 "../src/umockdev-pcap.vala"
		_tmp2_ = _tmp5_;
#line 88 "../src/umockdev-pcap.vala"
		if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 462 "umockdev-pcap.c"
			gboolean _tmp6_ = FALSE;
#line 88 "../src/umockdev-pcap.vala"
			if (_inner_error0_->domain == G_IO_ERROR) {
#line 466 "umockdev-pcap.c"
				goto __catch0_g_io_error;
			}
#line 88 "../src/umockdev-pcap.vala"
			_g_object_unref0 (data);
#line 88 "../src/umockdev-pcap.vala"
			g_critical ("file %s: line %d: unexpected error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
#line 88 "../src/umockdev-pcap.vala"
			g_clear_error (&_inner_error0_);
#line 88 "../src/umockdev-pcap.vala"
			return _tmp6_;
#line 477 "umockdev-pcap.c"
		}
#line 88 "../src/umockdev-pcap.vala"
		_tmp7_ = _tmp2_;
#line 88 "../src/umockdev-pcap.vala"
		_tmp2_ = NULL;
#line 88 "../src/umockdev-pcap.vala"
		_g_object_unref0 (data);
#line 88 "../src/umockdev-pcap.vala"
		data = _tmp7_;
#line 87 "../src/umockdev-pcap.vala"
		_g_object_unref0 (_tmp2_);
#line 489 "umockdev-pcap.c"
	}
	goto __finally0;
	__catch0_g_io_error:
	{
		GError* e = NULL;
		GError* _tmp8_;
		const gchar* _tmp9_;
#line 87 "../src/umockdev-pcap.vala"
		e = _inner_error0_;
#line 87 "../src/umockdev-pcap.vala"
		_inner_error0_ = NULL;
#line 90 "../src/umockdev-pcap.vala"
		_tmp8_ = e;
#line 90 "../src/umockdev-pcap.vala"
		_tmp9_ = _tmp8_->message;
#line 90 "../src/umockdev-pcap.vala"
		g_warning ("umockdev-pcap.vala:90: Error resolving IOCtl data: %s", _tmp9_);
#line 91 "../src/umockdev-pcap.vala"
		result = FALSE;
#line 91 "../src/umockdev-pcap.vala"
		_g_error_free0 (e);
#line 91 "../src/umockdev-pcap.vala"
		_g_object_unref0 (data);
#line 91 "../src/umockdev-pcap.vala"
		return result;
#line 515 "umockdev-pcap.c"
	}
	__finally0:
#line 87 "../src/umockdev-pcap.vala"
	if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 520 "umockdev-pcap.c"
		gboolean _tmp10_ = FALSE;
#line 87 "../src/umockdev-pcap.vala"
		_g_object_unref0 (data);
#line 87 "../src/umockdev-pcap.vala"
		g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
#line 87 "../src/umockdev-pcap.vala"
		g_clear_error (&_inner_error0_);
#line 87 "../src/umockdev-pcap.vala"
		return _tmp10_;
#line 530 "umockdev-pcap.c"
	}
#line 94 "../src/umockdev-pcap.vala"
	switch (request) {
#line 94 "../src/umockdev-pcap.vala"
		case USBDEVFS_GET_CAPABILITIES:
#line 536 "umockdev-pcap.c"
		{
			UMockdevIoctlData* _tmp11_;
			guint8* _tmp12_;
			gint _tmp12__length1;
#line 96 "../src/umockdev-pcap.vala"
			_tmp11_ = data;
#line 96 "../src/umockdev-pcap.vala"
			_tmp12_ = _tmp11_->data;
#line 96 "../src/umockdev-pcap.vala"
			_tmp12__length1 = _tmp11_->data_len;
#line 96 "../src/umockdev-pcap.vala"
			*((guint32*) _tmp12_) = UMOCKDEV_IOCTL_USB_PCAP_HANDLER_capabilities;
#line 98 "../src/umockdev-pcap.vala"
			umockdev_ioctl_client_complete (client, (glong) 0, 0);
#line 99 "../src/umockdev-pcap.vala"
			result = TRUE;
#line 99 "../src/umockdev-pcap.vala"
			_g_object_unref0 (data);
#line 99 "../src/umockdev-pcap.vala"
			return result;
#line 557 "umockdev-pcap.c"
		}
#line 94 "../src/umockdev-pcap.vala"
		case USBDEVFS_CLAIMINTERFACE:
#line 94 "../src/umockdev-pcap.vala"
		case USBDEVFS_RELEASEINTERFACE:
#line 94 "../src/umockdev-pcap.vala"
		case USBDEVFS_CLEAR_HALT:
#line 94 "../src/umockdev-pcap.vala"
		case USBDEVFS_RESET:
#line 94 "../src/umockdev-pcap.vala"
		case USBDEVFS_RESETEP:
#line 569 "umockdev-pcap.c"
		{
#line 106 "../src/umockdev-pcap.vala"
			umockdev_ioctl_client_complete (client, (glong) 0, 0);
#line 107 "../src/umockdev-pcap.vala"
			result = TRUE;
#line 107 "../src/umockdev-pcap.vala"
			_g_object_unref0 (data);
#line 107 "../src/umockdev-pcap.vala"
			return result;
#line 579 "umockdev-pcap.c"
		}
#line 94 "../src/umockdev-pcap.vala"
		case USBDEVFS_DISCARDURB:
#line 583 "umockdev-pcap.c"
		{
			{
				gint i = 0;
#line 110 "../src/umockdev-pcap.vala"
				i = 0;
#line 589 "umockdev-pcap.c"
				{
					gboolean _tmp13_ = FALSE;
#line 110 "../src/umockdev-pcap.vala"
					_tmp13_ = TRUE;
#line 110 "../src/umockdev-pcap.vala"
					while (TRUE) {
#line 596 "umockdev-pcap.c"
						GArray* _tmp15_;
						GArray* _tmp16_;
						UMockdevIoctlData* _tmp17_;
						UMockdevIoctlData* _tmp18_;
						UMockdevIoctlData* _tmp19_;
						guint8* _tmp20_;
						gint _tmp20__length1;
#line 110 "../src/umockdev-pcap.vala"
						if (!_tmp13_) {
#line 606 "umockdev-pcap.c"
							gint _tmp14_;
#line 110 "../src/umockdev-pcap.vala"
							_tmp14_ = i;
#line 110 "../src/umockdev-pcap.vala"
							i = _tmp14_ + 1;
#line 612 "umockdev-pcap.c"
						}
#line 110 "../src/umockdev-pcap.vala"
						_tmp13_ = FALSE;
#line 110 "../src/umockdev-pcap.vala"
						_tmp15_ = self->priv->urbs;
#line 110 "../src/umockdev-pcap.vala"
						if (!(((guint) i) < _tmp15_->len)) {
#line 110 "../src/umockdev-pcap.vala"
							break;
#line 622 "umockdev-pcap.c"
						}
#line 111 "../src/umockdev-pcap.vala"
						_tmp16_ = self->priv->urbs;
#line 111 "../src/umockdev-pcap.vala"
						_tmp17_ = (*g_array_index (_tmp16_, UMockdevUrbInfo*, (guint) i)).urb_data;
#line 111 "../src/umockdev-pcap.vala"
						_tmp18_ = umockdev_ioctl_client_get_arg (client);
#line 111 "../src/umockdev-pcap.vala"
						_tmp19_ = _tmp18_;
#line 111 "../src/umockdev-pcap.vala"
						_tmp20_ = _tmp19_->data;
#line 111 "../src/umockdev-pcap.vala"
						_tmp20__length1 = _tmp19_->data_len;
#line 111 "../src/umockdev-pcap.vala"
						if (_tmp17_->client_addr == (*((gulong*) _tmp20_))) {
#line 638 "umockdev-pcap.c"
							GArray* _tmp21_;
							GArray* _tmp22_;
							UMockdevUrbInfo* _tmp23_;
							GArray* _tmp24_;
							UMockdevUrbInfo* _tmp25_;
							UMockdevUrbInfo* _tmp26_;
#line 113 "../src/umockdev-pcap.vala"
							_tmp21_ = self->priv->discarded;
#line 113 "../src/umockdev-pcap.vala"
							_tmp22_ = self->priv->urbs;
#line 113 "../src/umockdev-pcap.vala"
							_tmp23_ = _umockdev_urb_info_dup0 (g_array_index (_tmp22_, UMockdevUrbInfo*, (guint) i));
#line 113 "../src/umockdev-pcap.vala"
							g_array_prepend_val (_tmp21_, _tmp23_);
#line 114 "../src/umockdev-pcap.vala"
							_tmp24_ = self->priv->urbs;
#line 114 "../src/umockdev-pcap.vala"
							_tmp25_ = vala_g_array_remove_index (_tmp24_, (guint) i);
#line 114 "../src/umockdev-pcap.vala"
							_tmp26_ = _tmp25_;
#line 114 "../src/umockdev-pcap.vala"
							_umockdev_urb_info_free0 (_tmp26_);
#line 115 "../src/umockdev-pcap.vala"
							umockdev_ioctl_client_complete (client, (glong) 0, 0);
#line 116 "../src/umockdev-pcap.vala"
							result = TRUE;
#line 116 "../src/umockdev-pcap.vala"
							_g_object_unref0 (data);
#line 116 "../src/umockdev-pcap.vala"
							return result;
#line 669 "umockdev-pcap.c"
						}
					}
				}
			}
#line 120 "../src/umockdev-pcap.vala"
			umockdev_ioctl_client_complete (client, (glong) -1, EINVAL);
#line 121 "../src/umockdev-pcap.vala"
			result = TRUE;
#line 121 "../src/umockdev-pcap.vala"
			_g_object_unref0 (data);
#line 121 "../src/umockdev-pcap.vala"
			return result;
#line 682 "umockdev-pcap.c"
		}
#line 94 "../src/umockdev-pcap.vala"
		case USBDEVFS_SUBMITURB:
#line 686 "umockdev-pcap.c"
		{
			struct usbdevfs_urb* urb = NULL;
			UMockdevIoctlData* _tmp27_;
			guint8* _tmp28_;
			gint _tmp28__length1;
			gsize offset = 0UL;
			struct usbdevfs_urb* _tmp29_;
			UMockdevUrbInfo info = {0};
			UMockdevUrbInfo _tmp30_ = {0};
			UMockdevIoctlData* _tmp31_;
			UMockdevIoctlData* _tmp32_;
			GArray* _tmp42_;
			UMockdevUrbInfo _tmp43_;
			UMockdevUrbInfo _tmp44_;
			UMockdevUrbInfo* _tmp45_;
#line 126 "../src/umockdev-pcap.vala"
			_tmp27_ = data;
#line 126 "../src/umockdev-pcap.vala"
			_tmp28_ = _tmp27_->data;
#line 126 "../src/umockdev-pcap.vala"
			_tmp28__length1 = _tmp27_->data_len;
#line 126 "../src/umockdev-pcap.vala"
			urb = (struct usbdevfs_urb*) _tmp28_;
#line 127 "../src/umockdev-pcap.vala"
			_tmp29_ = urb;
#line 127 "../src/umockdev-pcap.vala"
			offset = (gsize) (((gulong) (&(*urb).buffer)) - ((gulong) _tmp29_));
#line 128 "../src/umockdev-pcap.vala"
			info = _tmp30_;
#line 130 "../src/umockdev-pcap.vala"
			_tmp31_ = data;
#line 130 "../src/umockdev-pcap.vala"
			_tmp32_ = _g_object_ref0 (_tmp31_);
#line 130 "../src/umockdev-pcap.vala"
			_g_object_unref0 (info.urb_data);
#line 130 "../src/umockdev-pcap.vala"
			info.urb_data = _tmp32_;
#line 724 "umockdev-pcap.c"
			{
				UMockdevIoctlData* _tmp33_ = NULL;
				UMockdevIoctlData* _tmp34_;
				struct usbdevfs_urb* _tmp35_;
				UMockdevIoctlData* _tmp36_;
				UMockdevIoctlData* _tmp38_;
#line 132 "../src/umockdev-pcap.vala"
				_tmp34_ = data;
#line 132 "../src/umockdev-pcap.vala"
				_tmp35_ = urb;
#line 132 "../src/umockdev-pcap.vala"
				_tmp36_ = umockdev_ioctl_data_resolve (_tmp34_, offset, (gsize) (*_tmp35_).buffer_length, &_inner_error0_);
#line 132 "../src/umockdev-pcap.vala"
				_tmp33_ = _tmp36_;
#line 132 "../src/umockdev-pcap.vala"
				if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 741 "umockdev-pcap.c"
					gboolean _tmp37_ = FALSE;
#line 132 "../src/umockdev-pcap.vala"
					if (_inner_error0_->domain == G_IO_ERROR) {
#line 745 "umockdev-pcap.c"
						goto __catch1_g_io_error;
					}
#line 132 "../src/umockdev-pcap.vala"
					umockdev_urb_info_destroy (&info);
#line 132 "../src/umockdev-pcap.vala"
					_g_object_unref0 (data);
#line 132 "../src/umockdev-pcap.vala"
					g_critical ("file %s: line %d: unexpected error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
#line 132 "../src/umockdev-pcap.vala"
					g_clear_error (&_inner_error0_);
#line 132 "../src/umockdev-pcap.vala"
					return _tmp37_;
#line 758 "umockdev-pcap.c"
				}
#line 132 "../src/umockdev-pcap.vala"
				_tmp38_ = _tmp33_;
#line 132 "../src/umockdev-pcap.vala"
				_tmp33_ = NULL;
#line 132 "../src/umockdev-pcap.vala"
				_g_object_unref0 (info.buffer_data);
#line 132 "../src/umockdev-pcap.vala"
				info.buffer_data = _tmp38_;
#line 131 "../src/umockdev-pcap.vala"
				_g_object_unref0 (_tmp33_);
#line 770 "umockdev-pcap.c"
			}
			goto __finally1;
			__catch1_g_io_error:
			{
				GError* e = NULL;
				GError* _tmp39_;
				const gchar* _tmp40_;
#line 131 "../src/umockdev-pcap.vala"
				e = _inner_error0_;
#line 131 "../src/umockdev-pcap.vala"
				_inner_error0_ = NULL;
#line 134 "../src/umockdev-pcap.vala"
				_tmp39_ = e;
#line 134 "../src/umockdev-pcap.vala"
				_tmp40_ = _tmp39_->message;
#line 134 "../src/umockdev-pcap.vala"
				g_warning ("umockdev-pcap.vala:134: Error resolving IOCtl data: %s", _tmp40_);
#line 135 "../src/umockdev-pcap.vala"
				result = FALSE;
#line 135 "../src/umockdev-pcap.vala"
				_g_error_free0 (e);
#line 135 "../src/umockdev-pcap.vala"
				umockdev_urb_info_destroy (&info);
#line 135 "../src/umockdev-pcap.vala"
				_g_object_unref0 (data);
#line 135 "../src/umockdev-pcap.vala"
				return result;
#line 798 "umockdev-pcap.c"
			}
			__finally1:
#line 131 "../src/umockdev-pcap.vala"
			if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 803 "umockdev-pcap.c"
				gboolean _tmp41_ = FALSE;
#line 131 "../src/umockdev-pcap.vala"
				umockdev_urb_info_destroy (&info);
#line 131 "../src/umockdev-pcap.vala"
				_g_object_unref0 (data);
#line 131 "../src/umockdev-pcap.vala"
				g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
#line 131 "../src/umockdev-pcap.vala"
				g_clear_error (&_inner_error0_);
#line 131 "../src/umockdev-pcap.vala"
				return _tmp41_;
#line 815 "umockdev-pcap.c"
			}
#line 137 "../src/umockdev-pcap.vala"
			info.pcap_id = (guint64) 0;
#line 139 "../src/umockdev-pcap.vala"
			_tmp42_ = self->priv->urbs;
#line 139 "../src/umockdev-pcap.vala"
			_tmp43_ = info;
#line 139 "../src/umockdev-pcap.vala"
			_tmp44_ = _tmp43_;
#line 139 "../src/umockdev-pcap.vala"
			_tmp45_ = _umockdev_urb_info_dup0 (&_tmp44_);
#line 139 "../src/umockdev-pcap.vala"
			g_array_append_val (_tmp42_, _tmp45_);
#line 140 "../src/umockdev-pcap.vala"
			umockdev_ioctl_client_complete (client, (glong) 0, 0);
#line 141 "../src/umockdev-pcap.vala"
			result = TRUE;
#line 141 "../src/umockdev-pcap.vala"
			umockdev_urb_info_destroy (&info);
#line 141 "../src/umockdev-pcap.vala"
			_g_object_unref0 (data);
#line 141 "../src/umockdev-pcap.vala"
			return result;
#line 839 "umockdev-pcap.c"
		}
#line 94 "../src/umockdev-pcap.vala"
		case USBDEVFS_REAPURB:
#line 94 "../src/umockdev-pcap.vala"
		case USBDEVFS_REAPURBNDELAY:
#line 845 "umockdev-pcap.c"
		{
			UMockdevUrbInfo* urb_info = NULL;
			GArray* _tmp46_;
			UMockdevUrbInfo* _tmp62_;
#line 145 "../src/umockdev-pcap.vala"
			urb_info = NULL;
#line 146 "../src/umockdev-pcap.vala"
			_tmp46_ = self->priv->discarded;
#line 146 "../src/umockdev-pcap.vala"
			if (_tmp46_->len > ((guint) 0)) {
#line 856 "umockdev-pcap.c"
				GArray* _tmp47_;
				UMockdevUrbInfo* _tmp48_;
				GArray* _tmp49_;
				UMockdevUrbInfo* _tmp50_;
				UMockdevUrbInfo* _tmp51_;
				struct usbdevfs_urb* urb = NULL;
				UMockdevUrbInfo* _tmp52_;
				UMockdevIoctlData* _tmp53_;
				guint8* _tmp54_;
				gint _tmp54__length1;
				UMockdevUrbInfo* _tmp55_;
#line 147 "../src/umockdev-pcap.vala"
				_tmp47_ = self->priv->discarded;
#line 147 "../src/umockdev-pcap.vala"
				_tmp48_ = _umockdev_urb_info_dup0 (g_array_index (_tmp47_, UMockdevUrbInfo*, (guint) 0));
#line 147 "../src/umockdev-pcap.vala"
				_umockdev_urb_info_free0 (urb_info);
#line 147 "../src/umockdev-pcap.vala"
				urb_info = _tmp48_;
#line 148 "../src/umockdev-pcap.vala"
				_tmp49_ = self->priv->discarded;
#line 148 "../src/umockdev-pcap.vala"
				_tmp50_ = vala_g_array_remove_index (_tmp49_, (guint) 0);
#line 148 "../src/umockdev-pcap.vala"
				_tmp51_ = _tmp50_;
#line 148 "../src/umockdev-pcap.vala"
				_umockdev_urb_info_free0 (_tmp51_);
#line 150 "../src/umockdev-pcap.vala"
				_tmp52_ = urb_info;
#line 150 "../src/umockdev-pcap.vala"
				_tmp53_ = (*_tmp52_).urb_data;
#line 150 "../src/umockdev-pcap.vala"
				_tmp54_ = _tmp53_->data;
#line 150 "../src/umockdev-pcap.vala"
				_tmp54__length1 = _tmp53_->data_len;
#line 150 "../src/umockdev-pcap.vala"
				urb = (struct usbdevfs_urb*) _tmp54_;
#line 151 "../src/umockdev-pcap.vala"
				(*urb).status = -ENOENT;
#line 157 "../src/umockdev-pcap.vala"
				_tmp55_ = urb_info;
#line 157 "../src/umockdev-pcap.vala"
				if ((*_tmp55_).pcap_id == ((guint64) 0)) {
#line 900 "umockdev-pcap.c"
					struct usbdevfs_urb* _tmp56_;
					gchar* _tmp57_;
					gchar* _tmp58_;
					struct usbdevfs_urb* _tmp59_;
					struct usbdevfs_urb* _tmp60_;
#line 158 "../src/umockdev-pcap.vala"
					_tmp56_ = urb;
#line 158 "../src/umockdev-pcap.vala"
					_tmp57_ = umockdev_urb_type_to_string ((gint) (*_tmp56_).type);
#line 158 "../src/umockdev-pcap.vala"
					_tmp58_ = _tmp57_;
#line 158 "../src/umockdev-pcap.vala"
					_tmp59_ = urb;
#line 158 "../src/umockdev-pcap.vala"
					_tmp60_ = urb;
#line 158 "../src/umockdev-pcap.vala"
					g_message ("umockdev-pcap.vala:158: Replay may be stuck: Reaping discard URB of ty" \
"pe %s, for endpoint 0x%02x with length %d without corresponding submit", _tmp58_, (guint) (*_tmp59_).endpoint, (*_tmp60_).buffer_length);
#line 158 "../src/umockdev-pcap.vala"
					_g_free0 (_tmp58_);
#line 920 "umockdev-pcap.c"
				}
			} else {
				UMockdevUrbInfo* _tmp61_;
#line 162 "../src/umockdev-pcap.vala"
				_tmp61_ = umockdev_ioctl_usb_pcap_handler_next_reapable_urb (self);
#line 162 "../src/umockdev-pcap.vala"
				_umockdev_urb_info_free0 (urb_info);
#line 162 "../src/umockdev-pcap.vala"
				urb_info = _tmp61_;
#line 930 "umockdev-pcap.c"
			}
#line 165 "../src/umockdev-pcap.vala"
			_tmp62_ = urb_info;
#line 165 "../src/umockdev-pcap.vala"
			if (_tmp62_ != NULL) {
#line 936 "umockdev-pcap.c"
				UMockdevIoctlData* _tmp63_;
				UMockdevUrbInfo* _tmp64_;
				UMockdevIoctlData* _tmp65_;
#line 166 "../src/umockdev-pcap.vala"
				_tmp63_ = data;
#line 166 "../src/umockdev-pcap.vala"
				_tmp64_ = urb_info;
#line 166 "../src/umockdev-pcap.vala"
				_tmp65_ = (*_tmp64_).urb_data;
#line 166 "../src/umockdev-pcap.vala"
				umockdev_ioctl_data_set_ptr (_tmp63_, (gsize) 0, _tmp65_);
#line 167 "../src/umockdev-pcap.vala"
				umockdev_ioctl_client_complete (client, (glong) 0, 0);
#line 168 "../src/umockdev-pcap.vala"
				result = TRUE;
#line 168 "../src/umockdev-pcap.vala"
				_umockdev_urb_info_free0 (urb_info);
#line 168 "../src/umockdev-pcap.vala"
				_g_object_unref0 (data);
#line 168 "../src/umockdev-pcap.vala"
				return result;
#line 958 "umockdev-pcap.c"
			} else {
#line 170 "../src/umockdev-pcap.vala"
				umockdev_ioctl_client_complete (client, (glong) -1, EAGAIN);
#line 171 "../src/umockdev-pcap.vala"
				result = TRUE;
#line 171 "../src/umockdev-pcap.vala"
				_umockdev_urb_info_free0 (urb_info);
#line 171 "../src/umockdev-pcap.vala"
				_g_object_unref0 (data);
#line 171 "../src/umockdev-pcap.vala"
				return result;
#line 970 "umockdev-pcap.c"
			}
#line 94 "../src/umockdev-pcap.vala"
			_umockdev_urb_info_free0 (urb_info);
#line 974 "umockdev-pcap.c"
		}
		default:
		{
#line 175 "../src/umockdev-pcap.vala"
			umockdev_ioctl_client_complete (client, (glong) -1, ENOTTY);
#line 176 "../src/umockdev-pcap.vala"
			result = TRUE;
#line 176 "../src/umockdev-pcap.vala"
			_g_object_unref0 (data);
#line 176 "../src/umockdev-pcap.vala"
			return result;
#line 986 "umockdev-pcap.c"
		}
	}
}

static UMockdevUrbInfo*
umockdev_ioctl_usb_pcap_handler_next_reapable_urb (UMockdevIoctlUsbPcapHandler* self)
{
	gboolean debug = FALSE;
	guint64 now = 0ULL;
	GArray* _tmp0_;
	guint8* _tmp1_;
	gint _tmp1__length1;
	UMockdevUrbInfo* result;
#line 189 "../src/umockdev-pcap.vala"
	g_return_val_if_fail (self != NULL, NULL);
#line 190 "../src/umockdev-pcap.vala"
	debug = FALSE;
#line 191 "../src/umockdev-pcap.vala"
	now = (guint64) g_get_monotonic_time ();
#line 197 "../src/umockdev-pcap.vala"
	_tmp0_ = self->priv->urbs;
#line 197 "../src/umockdev-pcap.vala"
	if (_tmp0_->len == ((guint) 0)) {
#line 198 "../src/umockdev-pcap.vala"
		result = NULL;
#line 198 "../src/umockdev-pcap.vala"
		return result;
#line 1014 "umockdev-pcap.c"
	}
#line 201 "../src/umockdev-pcap.vala"
	_tmp1_ = self->priv->cur_buf;
#line 201 "../src/umockdev-pcap.vala"
	_tmp1__length1 = self->priv->cur_buf_length1;
#line 201 "../src/umockdev-pcap.vala"
	if (_tmp1_ == NULL) {
#line 1022 "umockdev-pcap.c"
		pcap_t* _tmp2_;
		guint8* _tmp3_;
		guint8* _tmp4_;
		gint _tmp4__length1;
		pcap_usb_header_mmapped* urb_hdr = NULL;
		guint8* _tmp5_;
		gint _tmp5__length1;
		pcap_usb_header_mmapped* _tmp6_;
		pcap_usb_header_mmapped* _tmp7_;
#line 202 "../src/umockdev-pcap.vala"
		_tmp2_ = self->priv->rec;
#line 202 "../src/umockdev-pcap.vala"
		_tmp3_ = pcap_next (_tmp2_, &self->priv->cur_hdr);
#line 202 "../src/umockdev-pcap.vala"
		self->priv->cur_buf = _tmp3_;
#line 202 "../src/umockdev-pcap.vala"
		self->priv->cur_buf_length1 = -1;
#line 202 "../src/umockdev-pcap.vala"
		self->priv->_cur_buf_size_ = self->priv->cur_buf_length1;
#line 204 "../src/umockdev-pcap.vala"
		_tmp4_ = self->priv->cur_buf;
#line 204 "../src/umockdev-pcap.vala"
		_tmp4__length1 = self->priv->cur_buf_length1;
#line 204 "../src/umockdev-pcap.vala"
		if (_tmp4_ == NULL) {
#line 205 "../src/umockdev-pcap.vala"
			result = NULL;
#line 205 "../src/umockdev-pcap.vala"
			return result;
#line 1052 "umockdev-pcap.c"
		}
#line 207 "../src/umockdev-pcap.vala"
		_tmp5_ = self->priv->cur_buf;
#line 207 "../src/umockdev-pcap.vala"
		_tmp5__length1 = self->priv->cur_buf_length1;
#line 207 "../src/umockdev-pcap.vala"
		urb_hdr = (void*) _tmp5_;
#line 209 "../src/umockdev-pcap.vala"
		self->priv->cur_waiting_since = now;
#line 210 "../src/umockdev-pcap.vala"
		_tmp6_ = urb_hdr;
#line 210 "../src/umockdev-pcap.vala"
		_tmp7_ = urb_hdr;
#line 210 "../src/umockdev-pcap.vala"
		self->priv->last_pkt_time_ms = ((*_tmp6_).ts_sec * 1000) + ((*_tmp7_).ts_usec / 1000);
#line 211 "../src/umockdev-pcap.vala"
		self->priv->start_time_ms = self->priv->last_pkt_time_ms;
#line 1070 "umockdev-pcap.c"
	}
	{
		gboolean _tmp8_ = FALSE;
#line 214 "../src/umockdev-pcap.vala"
		_tmp8_ = TRUE;
#line 214 "../src/umockdev-pcap.vala"
		while (TRUE) {
#line 1078 "umockdev-pcap.c"
			guint8* _tmp11_;
			gint _tmp11__length1;
			struct pcap_pkthdr _tmp12_;
			pcap_usb_header_mmapped* urb_hdr = NULL;
			guint8* _tmp13_;
			gint _tmp13__length1;
			guint64 cur_pkt_time_ms = 0ULL;
			pcap_usb_header_mmapped* _tmp14_;
			pcap_usb_header_mmapped* _tmp15_;
			gboolean _tmp16_ = FALSE;
			pcap_usb_header_mmapped* _tmp17_;
			pcap_usb_header_mmapped* _tmp40_;
			pcap_usb_header_mmapped* _tmp128_;
#line 214 "../src/umockdev-pcap.vala"
			if (!_tmp8_) {
#line 1094 "umockdev-pcap.c"
				pcap_t* _tmp9_;
				guint8* _tmp10_;
#line 214 "../src/umockdev-pcap.vala"
				_tmp9_ = self->priv->rec;
#line 214 "../src/umockdev-pcap.vala"
				_tmp10_ = pcap_next (_tmp9_, &self->priv->cur_hdr);
#line 214 "../src/umockdev-pcap.vala"
				self->priv->cur_buf = _tmp10_;
#line 214 "../src/umockdev-pcap.vala"
				self->priv->cur_buf_length1 = -1;
#line 214 "../src/umockdev-pcap.vala"
				self->priv->_cur_buf_size_ = self->priv->cur_buf_length1;
#line 214 "../src/umockdev-pcap.vala"
				self->priv->cur_waiting_since = now;
#line 1109 "umockdev-pcap.c"
			}
#line 214 "../src/umockdev-pcap.vala"
			_tmp8_ = FALSE;
#line 214 "../src/umockdev-pcap.vala"
			_tmp11_ = self->priv->cur_buf;
#line 214 "../src/umockdev-pcap.vala"
			_tmp11__length1 = self->priv->cur_buf_length1;
#line 214 "../src/umockdev-pcap.vala"
			if (!(_tmp11_ != NULL)) {
#line 214 "../src/umockdev-pcap.vala"
				break;
#line 1121 "umockdev-pcap.c"
			}
#line 215 "../src/umockdev-pcap.vala"
			_tmp12_ = self->priv->cur_hdr;
#line 215 "../src/umockdev-pcap.vala"
			_vala_assert (_tmp12_.caplen >= ((guint32) 64), "cur_hdr.caplen >= 64");
#line 217 "../src/umockdev-pcap.vala"
			_tmp13_ = self->priv->cur_buf;
#line 217 "../src/umockdev-pcap.vala"
			_tmp13__length1 = self->priv->cur_buf_length1;
#line 217 "../src/umockdev-pcap.vala"
			urb_hdr = (void*) _tmp13_;
#line 219 "../src/umockdev-pcap.vala"
			_tmp14_ = urb_hdr;
#line 219 "../src/umockdev-pcap.vala"
			_tmp15_ = urb_hdr;
#line 219 "../src/umockdev-pcap.vala"
			cur_pkt_time_ms = ((*_tmp14_).ts_sec * 1000) + ((*_tmp15_).ts_usec / 1000);
#line 222 "../src/umockdev-pcap.vala"
			_tmp17_ = urb_hdr;
#line 222 "../src/umockdev-pcap.vala"
			if (((gint) (*_tmp17_).bus_id) != self->priv->bus) {
#line 222 "../src/umockdev-pcap.vala"
				_tmp16_ = TRUE;
#line 1145 "umockdev-pcap.c"
			} else {
				pcap_usb_header_mmapped* _tmp18_;
#line 222 "../src/umockdev-pcap.vala"
				_tmp18_ = urb_hdr;
#line 222 "../src/umockdev-pcap.vala"
				_tmp16_ = ((gint) (*_tmp18_).device_address) != self->priv->device;
#line 1152 "umockdev-pcap.c"
			}
#line 222 "../src/umockdev-pcap.vala"
			if (_tmp16_) {
#line 223 "../src/umockdev-pcap.vala"
				continue;
#line 1158 "umockdev-pcap.c"
			}
#line 228 "../src/umockdev-pcap.vala"
			if (((now - self->priv->cur_waiting_since) / 1000) > (2000 + (cur_pkt_time_ms - self->priv->last_pkt_time_ms))) {
#line 1162 "umockdev-pcap.c"
				pcap_usb_header_mmapped* _tmp19_;
				pcap_usb_header_mmapped* _tmp20_;
				gchar* _tmp21_;
				gchar* _tmp22_;
				pcap_usb_header_mmapped* _tmp23_;
				pcap_usb_header_mmapped* _tmp24_;
				GArray* _tmp25_;
#line 229 "../src/umockdev-pcap.vala"
				g_message ("umockdev-pcap.vala:229: Stuck for %lu ms, recording needed %lu ms", ((gulong) (now - self->priv->cur_waiting_since)) / 1000, (gulong) (cur_pkt_time_ms - self->priv->last_pkt_time_ms));
#line 232 "../src/umockdev-pcap.vala"
				_tmp19_ = urb_hdr;
#line 232 "../src/umockdev-pcap.vala"
				_tmp20_ = urb_hdr;
#line 232 "../src/umockdev-pcap.vala"
				_tmp21_ = umockdev_urb_type_to_string ((gint) (*_tmp20_).transfer_type);
#line 232 "../src/umockdev-pcap.vala"
				_tmp22_ = _tmp21_;
#line 232 "../src/umockdev-pcap.vala"
				_tmp23_ = urb_hdr;
#line 232 "../src/umockdev-pcap.vala"
				_tmp24_ = urb_hdr;
#line 232 "../src/umockdev-pcap.vala"
				g_message ("umockdev-pcap.vala:232: Trying to reap at recording position %c %s pac" \
"ket, for endpoint 0x%02x with length %u, replay may be stuck (time: %." \
"3f)", (gint) (*_tmp19_).event_type, _tmp22_, (guint) (*_tmp23_).endpoint_number, (guint) (*_tmp24_).urb_len, (cur_pkt_time_ms - self->priv->start_time_ms) / 1000.0);
#line 232 "../src/umockdev-pcap.vala"
				_g_free0 (_tmp22_);
#line 234 "../src/umockdev-pcap.vala"
				_tmp25_ = self->priv->urbs;
#line 234 "../src/umockdev-pcap.vala"
				g_message ("umockdev-pcap.vala:234: The device has currently %u in-flight URBs:", _tmp25_->len);
#line 1192 "umockdev-pcap.c"
				{
					gint i = 0;
#line 236 "../src/umockdev-pcap.vala"
					i = 0;
#line 1197 "umockdev-pcap.c"
					{
						gboolean _tmp26_ = FALSE;
#line 236 "../src/umockdev-pcap.vala"
						_tmp26_ = TRUE;
#line 236 "../src/umockdev-pcap.vala"
						while (TRUE) {
#line 1204 "umockdev-pcap.c"
							GArray* _tmp28_;
							UMockdevUrbInfo* urb_data = NULL;
							GArray* _tmp29_;
							struct usbdevfs_urb* urb = NULL;
							UMockdevUrbInfo* _tmp30_;
							UMockdevIoctlData* _tmp31_;
							guint8* _tmp32_;
							gint _tmp32__length1;
							const gchar* _tmp33_ = NULL;
							UMockdevUrbInfo* _tmp34_;
							struct usbdevfs_urb* _tmp35_;
							gchar* _tmp36_;
							gchar* _tmp37_;
							struct usbdevfs_urb* _tmp38_;
							struct usbdevfs_urb* _tmp39_;
#line 236 "../src/umockdev-pcap.vala"
							if (!_tmp26_) {
#line 1222 "umockdev-pcap.c"
								gint _tmp27_;
#line 236 "../src/umockdev-pcap.vala"
								_tmp27_ = i;
#line 236 "../src/umockdev-pcap.vala"
								i = _tmp27_ + 1;
#line 1228 "umockdev-pcap.c"
							}
#line 236 "../src/umockdev-pcap.vala"
							_tmp26_ = FALSE;
#line 236 "../src/umockdev-pcap.vala"
							_tmp28_ = self->priv->urbs;
#line 236 "../src/umockdev-pcap.vala"
							if (!(((guint) i) < _tmp28_->len)) {
#line 236 "../src/umockdev-pcap.vala"
								break;
#line 1238 "umockdev-pcap.c"
							}
#line 237 "../src/umockdev-pcap.vala"
							_tmp29_ = self->priv->urbs;
#line 237 "../src/umockdev-pcap.vala"
							urb_data = g_array_index (_tmp29_, UMockdevUrbInfo*, (guint) i);
#line 238 "../src/umockdev-pcap.vala"
							_tmp30_ = urb_data;
#line 238 "../src/umockdev-pcap.vala"
							_tmp31_ = (*_tmp30_).urb_data;
#line 238 "../src/umockdev-pcap.vala"
							_tmp32_ = _tmp31_->data;
#line 238 "../src/umockdev-pcap.vala"
							_tmp32__length1 = _tmp31_->data_len;
#line 238 "../src/umockdev-pcap.vala"
							urb = (struct usbdevfs_urb*) _tmp32_;
#line 242 "../src/umockdev-pcap.vala"
							_tmp34_ = urb_data;
#line 242 "../src/umockdev-pcap.vala"
							if ((*_tmp34_).pcap_id == ((guint64) 0)) {
#line 242 "../src/umockdev-pcap.vala"
								_tmp33_ = "NOT ";
#line 1260 "umockdev-pcap.c"
							} else {
#line 242 "../src/umockdev-pcap.vala"
								_tmp33_ = "";
#line 1264 "umockdev-pcap.c"
							}
#line 240 "../src/umockdev-pcap.vala"
							_tmp35_ = urb;
#line 240 "../src/umockdev-pcap.vala"
							_tmp36_ = umockdev_urb_type_to_string ((gint) (*_tmp35_).type);
#line 240 "../src/umockdev-pcap.vala"
							_tmp37_ = _tmp36_;
#line 240 "../src/umockdev-pcap.vala"
							_tmp38_ = urb;
#line 240 "../src/umockdev-pcap.vala"
							_tmp39_ = urb;
#line 240 "../src/umockdev-pcap.vala"
							g_message ("umockdev-pcap.vala:240:    %s URB, for endpoint 0x%02x with length %d;" \
" %ssubmitted", _tmp37_, (guint) (*_tmp38_).endpoint, (*_tmp39_).buffer_length, _tmp33_);
#line 240 "../src/umockdev-pcap.vala"
							_g_free0 (_tmp37_);
#line 1280 "umockdev-pcap.c"
						}
					}
				}
#line 244 "../src/umockdev-pcap.vala"
				self->priv->cur_waiting_since = now;
#line 245 "../src/umockdev-pcap.vala"
				debug = TRUE;
#line 1288 "umockdev-pcap.c"
			}
#line 249 "../src/umockdev-pcap.vala"
			_tmp40_ = urb_hdr;
#line 249 "../src/umockdev-pcap.vala"
			if ((*_tmp40_).event_type == ((guint8) 'S')) {
#line 1294 "umockdev-pcap.c"
				gint i = 0;
				GArray* _tmp96_;
				{
					gboolean _tmp41_ = FALSE;
#line 255 "../src/umockdev-pcap.vala"
					i = 0;
#line 255 "../src/umockdev-pcap.vala"
					_tmp41_ = TRUE;
#line 255 "../src/umockdev-pcap.vala"
					while (TRUE) {
#line 1305 "umockdev-pcap.c"
						GArray* _tmp43_;
						UMockdevUrbInfo* urb_data = NULL;
						GArray* _tmp44_;
						struct usbdevfs_urb* urb = NULL;
						UMockdevUrbInfo* _tmp45_;
						UMockdevIoctlData* _tmp46_;
						guint8* _tmp47_;
						gint _tmp47__length1;
						UMockdevUrbInfo* _tmp48_;
						guint8* urb_buffer = NULL;
						struct usbdevfs_urb* _tmp49_;
						guint8* _tmp50_;
						gint _tmp50__length1;
						gint urb_buffer_length = 0;
						struct usbdevfs_urb* _tmp51_;
						struct usbdevfs_urb* _tmp52_;
						gboolean _tmp55_ = FALSE;
						gboolean _tmp56_ = FALSE;
						struct usbdevfs_urb* _tmp57_;
						pcap_usb_header_mmapped* _tmp58_;
						gboolean _tmp65_ = FALSE;
						struct usbdevfs_urb* _tmp66_;
						pcap_usb_header_mmapped* _tmp70_;
						UMockdevUrbInfo* _tmp92_;
						pcap_usb_header_mmapped* _tmp93_;
						pcap_usb_header_mmapped* _tmp94_;
						pcap_usb_header_mmapped* _tmp95_;
#line 255 "../src/umockdev-pcap.vala"
						if (!_tmp41_) {
#line 1335 "umockdev-pcap.c"
							gint _tmp42_;
#line 255 "../src/umockdev-pcap.vala"
							_tmp42_ = i;
#line 255 "../src/umockdev-pcap.vala"
							i = _tmp42_ + 1;
#line 1341 "umockdev-pcap.c"
						}
#line 255 "../src/umockdev-pcap.vala"
						_tmp41_ = FALSE;
#line 255 "../src/umockdev-pcap.vala"
						_tmp43_ = self->priv->urbs;
#line 255 "../src/umockdev-pcap.vala"
						if (!(((guint) i) < _tmp43_->len)) {
#line 255 "../src/umockdev-pcap.vala"
							break;
#line 1351 "umockdev-pcap.c"
						}
#line 256 "../src/umockdev-pcap.vala"
						_tmp44_ = self->priv->urbs;
#line 256 "../src/umockdev-pcap.vala"
						urb_data = g_array_index (_tmp44_, UMockdevUrbInfo*, (guint) i);
#line 257 "../src/umockdev-pcap.vala"
						_tmp45_ = urb_data;
#line 257 "../src/umockdev-pcap.vala"
						_tmp46_ = (*_tmp45_).urb_data;
#line 257 "../src/umockdev-pcap.vala"
						_tmp47_ = _tmp46_->data;
#line 257 "../src/umockdev-pcap.vala"
						_tmp47__length1 = _tmp46_->data_len;
#line 257 "../src/umockdev-pcap.vala"
						urb = (struct usbdevfs_urb*) _tmp47_;
#line 260 "../src/umockdev-pcap.vala"
						_tmp48_ = urb_data;
#line 260 "../src/umockdev-pcap.vala"
						if ((*_tmp48_).pcap_id != ((guint64) 0)) {
#line 261 "../src/umockdev-pcap.vala"
							continue;
#line 1373 "umockdev-pcap.c"
						}
#line 263 "../src/umockdev-pcap.vala"
						_tmp49_ = urb;
#line 263 "../src/umockdev-pcap.vala"
						_tmp50_ = (*_tmp49_).buffer;
#line 263 "../src/umockdev-pcap.vala"
						_tmp50__length1 = -1;
#line 263 "../src/umockdev-pcap.vala"
						urb_buffer = _tmp50_;
#line 264 "../src/umockdev-pcap.vala"
						_tmp51_ = urb;
#line 264 "../src/umockdev-pcap.vala"
						urb_buffer_length = (*_tmp51_).buffer_length;
#line 269 "../src/umockdev-pcap.vala"
						_tmp52_ = urb;
#line 269 "../src/umockdev-pcap.vala"
						if (((gint) (*_tmp52_).type) == UMOCKDEV_URB_CONTROL) {
#line 1391 "umockdev-pcap.c"
							struct usbdevfs_urb* _tmp53_;
							guint8* _tmp54_;
							gint _tmp54__length1;
#line 270 "../src/umockdev-pcap.vala"
							_vala_assert (urb_buffer_length >= 8, "urb_buffer_length >= 8");
#line 271 "../src/umockdev-pcap.vala"
							_tmp53_ = urb;
#line 271 "../src/umockdev-pcap.vala"
							_tmp54_ = (*_tmp53_).buffer;
#line 271 "../src/umockdev-pcap.vala"
							_tmp54__length1 = -1;
#line 271 "../src/umockdev-pcap.vala"
							urb_buffer = &_tmp54_[8];
#line 272 "../src/umockdev-pcap.vala"
							urb_buffer_length -= 8;
#line 1407 "umockdev-pcap.c"
						}
#line 278 "../src/umockdev-pcap.vala"
						_tmp57_ = urb;
#line 278 "../src/umockdev-pcap.vala"
						_tmp58_ = urb_hdr;
#line 278 "../src/umockdev-pcap.vala"
						if ((*_tmp57_).type != (*_tmp58_).transfer_type) {
#line 278 "../src/umockdev-pcap.vala"
							_tmp56_ = TRUE;
#line 1417 "umockdev-pcap.c"
						} else {
							gboolean _tmp59_ = FALSE;
							struct usbdevfs_urb* _tmp60_;
#line 279 "../src/umockdev-pcap.vala"
							_tmp60_ = urb;
#line 279 "../src/umockdev-pcap.vala"
							if (((gint) (*_tmp60_).type) != UMOCKDEV_URB_CONTROL) {
#line 1425 "umockdev-pcap.c"
								struct usbdevfs_urb* _tmp61_;
								pcap_usb_header_mmapped* _tmp62_;
#line 279 "../src/umockdev-pcap.vala"
								_tmp61_ = urb;
#line 279 "../src/umockdev-pcap.vala"
								_tmp62_ = urb_hdr;
#line 279 "../src/umockdev-pcap.vala"
								_tmp59_ = (*_tmp61_).endpoint != (*_tmp62_).endpoint_number;
#line 1434 "umockdev-pcap.c"
							} else {
#line 279 "../src/umockdev-pcap.vala"
								_tmp59_ = FALSE;
#line 1438 "umockdev-pcap.c"
							}
#line 279 "../src/umockdev-pcap.vala"
							_tmp56_ = _tmp59_;
#line 1442 "umockdev-pcap.c"
						}
#line 278 "../src/umockdev-pcap.vala"
						if (_tmp56_) {
#line 278 "../src/umockdev-pcap.vala"
							_tmp55_ = TRUE;
#line 1448 "umockdev-pcap.c"
						} else {
							pcap_usb_header_mmapped* _tmp63_;
#line 280 "../src/umockdev-pcap.vala"
							_tmp63_ = urb_hdr;
#line 280 "../src/umockdev-pcap.vala"
							_tmp55_ = ((guint32) urb_buffer_length) != (*_tmp63_).urb_len;
#line 1455 "umockdev-pcap.c"
						}
#line 278 "../src/umockdev-pcap.vala"
						if (_tmp55_) {
#line 282 "../src/umockdev-pcap.vala"
							if (debug) {
#line 1461 "umockdev-pcap.c"
								FILE* _tmp64_;
#line 283 "../src/umockdev-pcap.vala"
								_tmp64_ = stderr;
#line 283 "../src/umockdev-pcap.vala"
								fprintf (_tmp64_, "UMockdev: Queued URB %d has a metadata mismatch!\n", i);
#line 1467 "umockdev-pcap.c"
							}
#line 284 "../src/umockdev-pcap.vala"
							continue;
#line 1471 "umockdev-pcap.c"
						}
#line 288 "../src/umockdev-pcap.vala"
						_tmp66_ = urb;
#line 288 "../src/umockdev-pcap.vala"
						if (((gint) (*_tmp66_).type) == UMOCKDEV_URB_CONTROL) {
#line 1477 "umockdev-pcap.c"
							pcap_usb_header_mmapped* _tmp67_;
#line 288 "../src/umockdev-pcap.vala"
							_tmp67_ = urb_hdr;
#line 288 "../src/umockdev-pcap.vala"
							_tmp65_ = ((gint) (*_tmp67_).setup_flag) == 0;
#line 1483 "umockdev-pcap.c"
						} else {
#line 288 "../src/umockdev-pcap.vala"
							_tmp65_ = FALSE;
#line 1487 "umockdev-pcap.c"
						}
#line 288 "../src/umockdev-pcap.vala"
						if (_tmp65_) {
#line 1491 "umockdev-pcap.c"
							struct usbdevfs_urb* _tmp68_;
							guint8* _tmp69_;
							gint _tmp69__length1;
#line 289 "../src/umockdev-pcap.vala"
							_tmp68_ = urb;
#line 289 "../src/umockdev-pcap.vala"
							_tmp69_ = (*_tmp68_).buffer;
#line 289 "../src/umockdev-pcap.vala"
							_tmp69__length1 = -1;
#line 289 "../src/umockdev-pcap.vala"
							if (memcmp (_tmp69_, &(*urb_hdr).s, (gsize) 8) != 0) {
#line 290 "../src/umockdev-pcap.vala"
								continue;
#line 1505 "umockdev-pcap.c"
							}
						}
#line 293 "../src/umockdev-pcap.vala"
						_tmp70_ = urb_hdr;
#line 293 "../src/umockdev-pcap.vala"
						if ((*_tmp70_).data_len > ((guint32) 0)) {
#line 1512 "umockdev-pcap.c"
							pcap_usb_header_mmapped* _tmp71_;
							pcap_usb_header_mmapped* _tmp72_;
							guint8* _tmp73_;
							guint8* _tmp74_;
							gint _tmp74__length1;
#line 295 "../src/umockdev-pcap.vala"
							_tmp71_ = urb_hdr;
#line 295 "../src/umockdev-pcap.vala"
							_vala_assert (((gint) (*_tmp71_).data_flag) == 0, "urb_hdr.data_flag == 0");
#line 296 "../src/umockdev-pcap.vala"
							_tmp72_ = urb_hdr;
#line 296 "../src/umockdev-pcap.vala"
							_vala_assert ((*_tmp72_).data_len == ((guint32) urb_buffer_length), "urb_hdr.data_len == urb_buffer_length");
#line 299 "../src/umockdev-pcap.vala"
							_tmp73_ = urb_buffer;
#line 299 "../src/umockdev-pcap.vala"
							_tmp74_ = self->priv->cur_buf;
#line 299 "../src/umockdev-pcap.vala"
							_tmp74__length1 = self->priv->cur_buf_length1;
#line 299 "../src/umockdev-pcap.vala"
							if (memcmp (_tmp73_, &_tmp74_[sizeof (pcap_usb_header_mmapped)], (gsize) urb_buffer_length) != 0) {
#line 300 "../src/umockdev-pcap.vala"
								if (debug) {
#line 1536 "umockdev-pcap.c"
									FILE* _tmp75_;
									FILE* _tmp83_;
									FILE* _tmp91_;
#line 301 "../src/umockdev-pcap.vala"
									_tmp75_ = stderr;
#line 301 "../src/umockdev-pcap.vala"
									fprintf (_tmp75_, "UMockdev: Queued URB %d has a buffer mismatch! Recording:", i);
#line 1544 "umockdev-pcap.c"
									{
										gint j = 0;
#line 302 "../src/umockdev-pcap.vala"
										j = 0;
#line 1549 "umockdev-pcap.c"
										{
											gboolean _tmp76_ = FALSE;
#line 302 "../src/umockdev-pcap.vala"
											_tmp76_ = TRUE;
#line 302 "../src/umockdev-pcap.vala"
											while (TRUE) {
#line 1556 "umockdev-pcap.c"
												gboolean _tmp78_ = FALSE;
												FILE* _tmp80_;
												guint8* _tmp81_;
												gint _tmp81__length1;
												guint8 _tmp82_;
#line 302 "../src/umockdev-pcap.vala"
												if (!_tmp76_) {
#line 1564 "umockdev-pcap.c"
													gint _tmp77_;
#line 302 "../src/umockdev-pcap.vala"
													_tmp77_ = j;
#line 302 "../src/umockdev-pcap.vala"
													j = _tmp77_ + 1;
#line 1570 "umockdev-pcap.c"
												}
#line 302 "../src/umockdev-pcap.vala"
												_tmp76_ = FALSE;
#line 302 "../src/umockdev-pcap.vala"
												if (!(j < urb_buffer_length)) {
#line 302 "../src/umockdev-pcap.vala"
													break;
#line 1578 "umockdev-pcap.c"
												}
#line 303 "../src/umockdev-pcap.vala"
												if (j > 0) {
#line 303 "../src/umockdev-pcap.vala"
													_tmp78_ = (j % 8) == 0;
#line 1584 "umockdev-pcap.c"
												} else {
#line 303 "../src/umockdev-pcap.vala"
													_tmp78_ = FALSE;
#line 1588 "umockdev-pcap.c"
												}
#line 303 "../src/umockdev-pcap.vala"
												if (_tmp78_) {
#line 1592 "umockdev-pcap.c"
													FILE* _tmp79_;
#line 304 "../src/umockdev-pcap.vala"
													_tmp79_ = stderr;
#line 304 "../src/umockdev-pcap.vala"
													fprintf (_tmp79_, "\n");
#line 1598 "umockdev-pcap.c"
												}
#line 305 "../src/umockdev-pcap.vala"
												_tmp80_ = stderr;
#line 305 "../src/umockdev-pcap.vala"
												_tmp81_ = self->priv->cur_buf;
#line 305 "../src/umockdev-pcap.vala"
												_tmp81__length1 = self->priv->cur_buf_length1;
#line 305 "../src/umockdev-pcap.vala"
												_tmp82_ = _tmp81_[sizeof (pcap_usb_header_mmapped) + j];
#line 305 "../src/umockdev-pcap.vala"
												fprintf (_tmp80_, " %02x", (guint) _tmp82_);
#line 1610 "umockdev-pcap.c"
											}
										}
									}
#line 307 "../src/umockdev-pcap.vala"
									_tmp83_ = stderr;
#line 307 "../src/umockdev-pcap.vala"
									fprintf (_tmp83_, "\nUMockdev: Submitted:");
#line 1618 "umockdev-pcap.c"
									{
										gint j = 0;
#line 308 "../src/umockdev-pcap.vala"
										j = 0;
#line 1623 "umockdev-pcap.c"
										{
											gboolean _tmp84_ = FALSE;
#line 308 "../src/umockdev-pcap.vala"
											_tmp84_ = TRUE;
#line 308 "../src/umockdev-pcap.vala"
											while (TRUE) {
#line 1630 "umockdev-pcap.c"
												gboolean _tmp86_ = FALSE;
												FILE* _tmp88_;
												guint8* _tmp89_;
												guint8 _tmp90_;
#line 308 "../src/umockdev-pcap.vala"
												if (!_tmp84_) {
#line 1637 "umockdev-pcap.c"
													gint _tmp85_;
#line 308 "../src/umockdev-pcap.vala"
													_tmp85_ = j;
#line 308 "../src/umockdev-pcap.vala"
													j = _tmp85_ + 1;
#line 1643 "umockdev-pcap.c"
												}
#line 308 "../src/umockdev-pcap.vala"
												_tmp84_ = FALSE;
#line 308 "../src/umockdev-pcap.vala"
												if (!(j < urb_buffer_length)) {
#line 308 "../src/umockdev-pcap.vala"
													break;
#line 1651 "umockdev-pcap.c"
												}
#line 309 "../src/umockdev-pcap.vala"
												if (j > 0) {
#line 309 "../src/umockdev-pcap.vala"
													_tmp86_ = (j % 8) == 0;
#line 1657 "umockdev-pcap.c"
												} else {
#line 309 "../src/umockdev-pcap.vala"
													_tmp86_ = FALSE;
#line 1661 "umockdev-pcap.c"
												}
#line 309 "../src/umockdev-pcap.vala"
												if (_tmp86_) {
#line 1665 "umockdev-pcap.c"
													FILE* _tmp87_;
#line 310 "../src/umockdev-pcap.vala"
													_tmp87_ = stderr;
#line 310 "../src/umockdev-pcap.vala"
													fprintf (_tmp87_, "\n");
#line 1671 "umockdev-pcap.c"
												}
#line 311 "../src/umockdev-pcap.vala"
												_tmp88_ = stderr;
#line 311 "../src/umockdev-pcap.vala"
												_tmp89_ = urb_buffer;
#line 311 "../src/umockdev-pcap.vala"
												_tmp90_ = _tmp89_[j];
#line 311 "../src/umockdev-pcap.vala"
												fprintf (_tmp88_, " %02x", (guint) _tmp90_);
#line 1681 "umockdev-pcap.c"
											}
										}
									}
#line 313 "../src/umockdev-pcap.vala"
									_tmp91_ = stderr;
#line 313 "../src/umockdev-pcap.vala"
									fprintf (_tmp91_, "\n");
#line 1689 "umockdev-pcap.c"
								}
#line 315 "../src/umockdev-pcap.vala"
								continue;
#line 1693 "umockdev-pcap.c"
							}
						}
#line 320 "../src/umockdev-pcap.vala"
						_tmp92_ = urb_data;
#line 320 "../src/umockdev-pcap.vala"
						_tmp93_ = urb_hdr;
#line 320 "../src/umockdev-pcap.vala"
						(*_tmp92_).pcap_id = (*_tmp93_).id;
#line 323 "../src/umockdev-pcap.vala"
						_tmp94_ = urb_hdr;
#line 323 "../src/umockdev-pcap.vala"
						_tmp95_ = urb_hdr;
#line 323 "../src/umockdev-pcap.vala"
						self->priv->last_pkt_time_ms = ((*_tmp94_).ts_sec * 1000) + ((*_tmp95_).ts_usec / 1000);
#line 324 "../src/umockdev-pcap.vala"
						break;
#line 1710 "umockdev-pcap.c"
					}
				}
#line 328 "../src/umockdev-pcap.vala"
				_tmp96_ = self->priv->urbs;
#line 328 "../src/umockdev-pcap.vala"
				if (((guint) i) != _tmp96_->len) {
#line 329 "../src/umockdev-pcap.vala"
					continue;
#line 1719 "umockdev-pcap.c"
				}
			} else {
				UMockdevUrbInfo* urb_info = NULL;
				struct usbdevfs_urb* urb = NULL;
				pcap_usb_header_mmapped* _tmp97_;
				struct usbdevfs_urb* _tmp111_;
				pcap_usb_header_mmapped* _tmp112_;
				pcap_usb_header_mmapped* _tmp122_;
				pcap_usb_header_mmapped* _tmp123_;
				pcap_usb_header_mmapped* _tmp124_;
				pcap_usb_header_mmapped* _tmp125_;
				pcap_usb_header_mmapped* _tmp126_;
				pcap_usb_header_mmapped* _tmp127_;
#line 331 "../src/umockdev-pcap.vala"
				urb_info = NULL;
#line 332 "../src/umockdev-pcap.vala"
				urb = NULL;
#line 335 "../src/umockdev-pcap.vala"
				_tmp97_ = urb_hdr;
#line 335 "../src/umockdev-pcap.vala"
				_vala_assert ((*_tmp97_).event_type == ((guint8) 'C'), "urb_hdr.event_type == 'C'");
#line 1741 "umockdev-pcap.c"
				{
					gint i = 0;
#line 337 "../src/umockdev-pcap.vala"
					i = 0;
#line 1746 "umockdev-pcap.c"
					{
						gboolean _tmp98_ = FALSE;
#line 337 "../src/umockdev-pcap.vala"
						_tmp98_ = TRUE;
#line 337 "../src/umockdev-pcap.vala"
						while (TRUE) {
#line 1753 "umockdev-pcap.c"
							GArray* _tmp100_;
							GArray* _tmp101_;
							UMockdevUrbInfo* _tmp102_;
							UMockdevUrbInfo* _tmp103_;
							pcap_usb_header_mmapped* _tmp104_;
#line 337 "../src/umockdev-pcap.vala"
							if (!_tmp98_) {
#line 1761 "umockdev-pcap.c"
								gint _tmp99_;
#line 337 "../src/umockdev-pcap.vala"
								_tmp99_ = i;
#line 337 "../src/umockdev-pcap.vala"
								i = _tmp99_ + 1;
#line 1767 "umockdev-pcap.c"
							}
#line 337 "../src/umockdev-pcap.vala"
							_tmp98_ = FALSE;
#line 337 "../src/umockdev-pcap.vala"
							_tmp100_ = self->priv->urbs;
#line 337 "../src/umockdev-pcap.vala"
							if (!(((guint) i) < _tmp100_->len)) {
#line 337 "../src/umockdev-pcap.vala"
								break;
#line 1777 "umockdev-pcap.c"
							}
#line 338 "../src/umockdev-pcap.vala"
							_tmp101_ = self->priv->urbs;
#line 338 "../src/umockdev-pcap.vala"
							_tmp102_ = _umockdev_urb_info_dup0 (g_array_index (_tmp101_, UMockdevUrbInfo*, (guint) i));
#line 338 "../src/umockdev-pcap.vala"
							_umockdev_urb_info_free0 (urb_info);
#line 338 "../src/umockdev-pcap.vala"
							urb_info = _tmp102_;
#line 340 "../src/umockdev-pcap.vala"
							_tmp103_ = urb_info;
#line 340 "../src/umockdev-pcap.vala"
							_tmp104_ = urb_hdr;
#line 340 "../src/umockdev-pcap.vala"
							if ((*_tmp103_).pcap_id == (*_tmp104_).id) {
#line 1793 "umockdev-pcap.c"
								UMockdevUrbInfo* _tmp105_;
								UMockdevIoctlData* _tmp106_;
								guint8* _tmp107_;
								gint _tmp107__length1;
								GArray* _tmp108_;
								UMockdevUrbInfo* _tmp109_;
								UMockdevUrbInfo* _tmp110_;
#line 341 "../src/umockdev-pcap.vala"
								_tmp105_ = urb_info;
#line 341 "../src/umockdev-pcap.vala"
								_tmp106_ = (*_tmp105_).urb_data;
#line 341 "../src/umockdev-pcap.vala"
								_tmp107_ = _tmp106_->data;
#line 341 "../src/umockdev-pcap.vala"
								_tmp107__length1 = _tmp106_->data_len;
#line 341 "../src/umockdev-pcap.vala"
								urb = (struct usbdevfs_urb*) _tmp107_;
#line 342 "../src/umockdev-pcap.vala"
								_tmp108_ = self->priv->urbs;
#line 342 "../src/umockdev-pcap.vala"
								_tmp109_ = vala_g_array_remove_index (_tmp108_, (guint) i);
#line 342 "../src/umockdev-pcap.vala"
								_tmp110_ = _tmp109_;
#line 342 "../src/umockdev-pcap.vala"
								_umockdev_urb_info_free0 (_tmp110_);
#line 343 "../src/umockdev-pcap.vala"
								break;
#line 1821 "umockdev-pcap.c"
							}
#line 346 "../src/umockdev-pcap.vala"
							_umockdev_urb_info_free0 (urb_info);
#line 346 "../src/umockdev-pcap.vala"
							urb_info = NULL;
#line 1827 "umockdev-pcap.c"
						}
					}
				}
#line 352 "../src/umockdev-pcap.vala"
				_tmp111_ = urb;
#line 352 "../src/umockdev-pcap.vala"
				if (_tmp111_ == NULL) {
#line 353 "../src/umockdev-pcap.vala"
					_umockdev_urb_info_free0 (urb_info);
#line 353 "../src/umockdev-pcap.vala"
					continue;
#line 1839 "umockdev-pcap.c"
				}
#line 358 "../src/umockdev-pcap.vala"
				_tmp112_ = urb_hdr;
#line 358 "../src/umockdev-pcap.vala"
				if ((*_tmp112_).data_len > ((guint32) 0)) {
#line 1845 "umockdev-pcap.c"
					pcap_usb_header_mmapped* _tmp113_;
					guint8* urb_buffer = NULL;
					struct usbdevfs_urb* _tmp114_;
					guint8* _tmp115_;
					gint _tmp115__length1;
					struct usbdevfs_urb* _tmp116_;
					guint8* _tmp119_;
					guint8* _tmp120_;
					gint _tmp120__length1;
					pcap_usb_header_mmapped* _tmp121_;
#line 359 "../src/umockdev-pcap.vala"
					_tmp113_ = urb_hdr;
#line 359 "../src/umockdev-pcap.vala"
					_vala_assert (((gint) (*_tmp113_).data_flag) == 0, "urb_hdr.data_flag == 0");
#line 361 "../src/umockdev-pcap.vala"
					_tmp114_ = urb;
#line 361 "../src/umockdev-pcap.vala"
					_tmp115_ = (*_tmp114_).buffer;
#line 361 "../src/umockdev-pcap.vala"
					_tmp115__length1 = -1;
#line 361 "../src/umockdev-pcap.vala"
					urb_buffer = _tmp115_;
#line 366 "../src/umockdev-pcap.vala"
					_tmp116_ = urb;
#line 366 "../src/umockdev-pcap.vala"
					if (((gint) (*_tmp116_).type) == UMOCKDEV_URB_CONTROL) {
#line 1872 "umockdev-pcap.c"
						struct usbdevfs_urb* _tmp117_;
						guint8* _tmp118_;
						gint _tmp118__length1;
#line 367 "../src/umockdev-pcap.vala"
						_tmp117_ = urb;
#line 367 "../src/umockdev-pcap.vala"
						_tmp118_ = (*_tmp117_).buffer;
#line 367 "../src/umockdev-pcap.vala"
						_tmp118__length1 = -1;
#line 367 "../src/umockdev-pcap.vala"
						urb_buffer = &_tmp118_[8];
#line 1884 "umockdev-pcap.c"
					}
#line 369 "../src/umockdev-pcap.vala"
					_tmp119_ = urb_buffer;
#line 369 "../src/umockdev-pcap.vala"
					_tmp120_ = self->priv->cur_buf;
#line 369 "../src/umockdev-pcap.vala"
					_tmp120__length1 = self->priv->cur_buf_length1;
#line 369 "../src/umockdev-pcap.vala"
					_tmp121_ = urb_hdr;
#line 369 "../src/umockdev-pcap.vala"
					memcpy (_tmp119_, &_tmp120_[sizeof (pcap_usb_header_mmapped)], (gsize) (*_tmp121_).data_len);
#line 1896 "umockdev-pcap.c"
				}
#line 371 "../src/umockdev-pcap.vala"
				_tmp122_ = urb_hdr;
#line 371 "../src/umockdev-pcap.vala"
				(*urb).status = (gint) (*_tmp122_).status;
#line 372 "../src/umockdev-pcap.vala"
				_tmp123_ = urb_hdr;
#line 372 "../src/umockdev-pcap.vala"
				(*urb).actual_length = (gint) (*_tmp123_).urb_len;
#line 375 "../src/umockdev-pcap.vala"
				_tmp124_ = urb_hdr;
#line 375 "../src/umockdev-pcap.vala"
				_vala_assert ((*_tmp124_).start_frame == ((guint32) 0), "urb_hdr.start_frame == 0");
#line 376 "../src/umockdev-pcap.vala"
				_tmp125_ = urb_hdr;
#line 376 "../src/umockdev-pcap.vala"
				(*urb).start_frame = (gint) (*_tmp125_).start_frame;
#line 378 "../src/umockdev-pcap.vala"
				_tmp126_ = urb_hdr;
#line 378 "../src/umockdev-pcap.vala"
				_tmp127_ = urb_hdr;
#line 378 "../src/umockdev-pcap.vala"
				self->priv->last_pkt_time_ms = ((*_tmp126_).ts_sec * 1000) + ((*_tmp127_).ts_usec / 1000);
#line 380 "../src/umockdev-pcap.vala"
				result = urb_info;
#line 380 "../src/umockdev-pcap.vala"
				return result;
#line 1924 "umockdev-pcap.c"
			}
#line 389 "../src/umockdev-pcap.vala"
			_tmp128_ = urb_hdr;
#line 389 "../src/umockdev-pcap.vala"
			if (((gint) (*_tmp128_).transfer_type) == UMOCKDEV_URB_CONTROL) {
#line 1930 "umockdev-pcap.c"
				gboolean _tmp129_ = FALSE;
				gboolean _tmp130_ = FALSE;
				pcap_usb_header_mmapped* _tmp131_;
#line 391 "../src/umockdev-pcap.vala"
				_tmp131_ = urb_hdr;
#line 391 "../src/umockdev-pcap.vala"
				if ((*_tmp131_).event_type == ((guint8) 'S')) {
#line 1938 "umockdev-pcap.c"
					pcap_usb_header_mmapped* _tmp132_;
#line 391 "../src/umockdev-pcap.vala"
					_tmp132_ = urb_hdr;
#line 391 "../src/umockdev-pcap.vala"
					_tmp130_ = ((gint) (*_tmp132_).setup_flag) == 0;
#line 1944 "umockdev-pcap.c"
				} else {
#line 391 "../src/umockdev-pcap.vala"
					_tmp130_ = FALSE;
#line 1948 "umockdev-pcap.c"
				}
#line 391 "../src/umockdev-pcap.vala"
				if (_tmp130_) {
#line 391 "../src/umockdev-pcap.vala"
					_tmp129_ = ((gint) ((*((guint8*) (&(*urb_hdr).s))) & 0x60)) == 0x00;
#line 1954 "umockdev-pcap.c"
				} else {
#line 391 "../src/umockdev-pcap.vala"
					_tmp129_ = FALSE;
#line 1958 "umockdev-pcap.c"
				}
#line 391 "../src/umockdev-pcap.vala"
				if (_tmp129_) {
#line 392 "../src/umockdev-pcap.vala"
					continue;
#line 1964 "umockdev-pcap.c"
				}
			}
#line 396 "../src/umockdev-pcap.vala"
			result = NULL;
#line 396 "../src/umockdev-pcap.vala"
			return result;
#line 1971 "umockdev-pcap.c"
		}
	}
#line 399 "../src/umockdev-pcap.vala"
	result = NULL;
#line 399 "../src/umockdev-pcap.vala"
	return result;
#line 1978 "umockdev-pcap.c"
}

static void
umockdev_ioctl_usb_pcap_handler_class_init (UMockdevIoctlUsbPcapHandlerClass * klass,
                                            gpointer klass_data)
{
#line 51 "../src/umockdev-pcap.vala"
	umockdev_ioctl_usb_pcap_handler_parent_class = g_type_class_peek_parent (klass);
#line 51 "../src/umockdev-pcap.vala"
	g_type_class_adjust_private_offset (klass, &UMockdevIoctlUsbPcapHandler_private_offset);
#line 51 "../src/umockdev-pcap.vala"
	((UMockdevIoctlBaseClass *) klass)->handle_ioctl = (gboolean (*) (UMockdevIoctlBase*, UMockdevIoctlClient*)) umockdev_ioctl_usb_pcap_handler_real_handle_ioctl;
#line 51 "../src/umockdev-pcap.vala"
	G_OBJECT_CLASS (klass)->finalize = umockdev_ioctl_usb_pcap_handler_finalize;
#line 1993 "umockdev-pcap.c"
}

static void
umockdev_ioctl_usb_pcap_handler_instance_init (UMockdevIoctlUsbPcapHandler * self,
                                               gpointer klass)
{
#line 51 "../src/umockdev-pcap.vala"
	self->priv = umockdev_ioctl_usb_pcap_handler_get_instance_private (self);
#line 187 "../src/umockdev-pcap.vala"
	self->priv->cur_buf = NULL;
#line 187 "../src/umockdev-pcap.vala"
	self->priv->cur_buf_length1 = 0;
#line 187 "../src/umockdev-pcap.vala"
	self->priv->_cur_buf_size_ = self->priv->cur_buf_length1;
#line 2008 "umockdev-pcap.c"
}

static void
umockdev_ioctl_usb_pcap_handler_finalize (GObject * obj)
{
	UMockdevIoctlUsbPcapHandler * self;
#line 51 "../src/umockdev-pcap.vala"
	self = G_TYPE_CHECK_INSTANCE_CAST (obj, UMOCKDEV_TYPE_IOCTL_USB_PCAP_HANDLER, UMockdevIoctlUsbPcapHandler);
#line 59 "../src/umockdev-pcap.vala"
	_pcap_close0 (self->priv->rec);
#line 60 "../src/umockdev-pcap.vala"
	_g_array_unref0 (self->priv->urbs);
#line 61 "../src/umockdev-pcap.vala"
	_g_array_unref0 (self->priv->discarded);
#line 51 "../src/umockdev-pcap.vala"
	G_OBJECT_CLASS (umockdev_ioctl_usb_pcap_handler_parent_class)->finalize (obj);
#line 2025 "umockdev-pcap.c"
}

static GType
umockdev_ioctl_usb_pcap_handler_get_type_once (void)
{
	static const GTypeInfo g_define_type_info = { sizeof (UMockdevIoctlUsbPcapHandlerClass), (GBaseInitFunc) NULL, (GBaseFinalizeFunc) NULL, (GClassInitFunc) umockdev_ioctl_usb_pcap_handler_class_init, (GClassFinalizeFunc) NULL, NULL, sizeof (UMockdevIoctlUsbPcapHandler), 0, (GInstanceInitFunc) umockdev_ioctl_usb_pcap_handler_instance_init, NULL };
	GType umockdev_ioctl_usb_pcap_handler_type_id;
	umockdev_ioctl_usb_pcap_handler_type_id = g_type_register_static (UMOCKDEV_TYPE_IOCTL_BASE, "UMockdevIoctlUsbPcapHandler", &g_define_type_info, 0);
	UMockdevIoctlUsbPcapHandler_private_offset = g_type_add_instance_private (umockdev_ioctl_usb_pcap_handler_type_id, sizeof (UMockdevIoctlUsbPcapHandlerPrivate));
	return umockdev_ioctl_usb_pcap_handler_type_id;
}

GType
umockdev_ioctl_usb_pcap_handler_get_type (void)
{
	static volatile gsize umockdev_ioctl_usb_pcap_handler_type_id__once = 0;
	if (g_once_init_enter (&umockdev_ioctl_usb_pcap_handler_type_id__once)) {
		GType umockdev_ioctl_usb_pcap_handler_type_id;
		umockdev_ioctl_usb_pcap_handler_type_id = umockdev_ioctl_usb_pcap_handler_get_type_once ();
		g_once_init_leave (&umockdev_ioctl_usb_pcap_handler_type_id__once, umockdev_ioctl_usb_pcap_handler_type_id);
	}
	return umockdev_ioctl_usb_pcap_handler_type_id__once;
}

static inline gpointer
_vala_memdup2 (gconstpointer mem,
               gsize byte_size)
{
	gpointer new_mem;
	if (mem && byte_size != 0) {
		new_mem = g_malloc (byte_size);
		memcpy (new_mem, mem, byte_size);
	} else {
		new_mem = NULL;
	}
	return new_mem;
}

